/* IN55 - TP2 - Exo 4 */
/* Matrices de transformation */

#include <GL/glut.h>

/* Dfinitions */
void Reshape(int,int);
void Draw();
void BuildCube(GLdouble,GLuint);
void BuildAxis(GLdouble,GLuint);

/* Variables statiques */
static GLuint genList;
static long cpt=0;

/* Fonction main */

int main( int argc, char **argv)
{
	//initialisation de Glut
	glutInit(&argc, argv);
	// Mode d'affichage
	glutInitDisplayMode(GLUT_RGBA|GLUT_DEPTH|GLUT_DOUBLE);
	// Taille et position de la fentre
	glutInitWindowSize(640,480);
	glutInitWindowPosition(200,200);  
	// Cration de la fentre
	glutCreateWindow("IN55 TP2 - Introduction  OpenGL - Exo 4");
	// Couleur d'effacement du buffer
	glClearColor(0.,0.,0.,1.);
	// Listes d'affichage : axes et cube
	genList = glGenLists(2);
	BuildAxis(10.0, genList);
	BuildCube(0.5, genList+1);
	// Fonction pour l'affichage
	glutDisplayFunc(Draw);
	// Fonction pour le redimentionnement
	glutReshapeFunc(Reshape);
	// Boucle de gestion des vnements
	glutMainLoop();
	
	return 0;
}

/* Cre un cube de ct entier spcifi 
 * Retourne un pointeur sur une Build List */
void BuildCube(GLdouble side, GLuint genList)
{
	//GLuint list = glGenLists(1);
	side = side/2;
	glNewList(genList,GL_COMPILE);
		glBegin(GL_QUADS);				// dbut du carr
			glColor3d(1.,0.,0.);			// rouge
			glVertex3f(+side,+side,+side);	// haut-gauche
			glVertex3f(+side,+side,-side);	// haut-droit
			glVertex3f(+side,-side,-side);	// bas-droit
			glVertex3f(+side,-side,+side);	// bas-gauche	
			glColor3d(0.,1.,0.);			// vert
			glVertex3f(-side,+side,+side);	// haut-gauche
			glVertex3f(+side,+side,+side);	// haut-droit
			glVertex3f(+side,-side,+side);	// bas-droit
			glVertex3f(-side,-side,+side);	// bas-gauche	
			glColor3d(0.,0.,1.);			// bleu
			glVertex3f(-side,+side,-side);	// haut-gauche
			glVertex3f(-side,+side,+side);	// haut-droit
			glVertex3f(-side,-side,+side);	// bas-droit
			glVertex3f(-side,-side,-side);	// bas-gauche	
			glColor3d(1.,1.,0.);			// magenta
			glVertex3f(+side,+side,-side);	// haut-gauche
			glVertex3f(-side,+side,-side);	// haut-droit
			glVertex3f(-side,-side,-side);	// bas-droit
			glVertex3f(+side,-side,-side);	// bas-gauche	
			glColor3d(0.,1.,1.);			// cyan
			glVertex3f(-side,+side,-side);	// haut-gauche
			glVertex3f(+side,+side,-side);	// haut-droit
			glVertex3f(+side,+side,+side);	// bas-droit
			glVertex3f(-side,+side,+side);	// bas-gauche	
			glColor3d(1.,0.,1.);			// jaune
			glVertex3f(-side,-side,+side);	// haut-gauche
			glVertex3f(+side,-side,+side);	// haut-droit
			glVertex3f(+side,-side,-side);	// bas-droit
			glVertex3f(-side,-side,-side);	// bas-gauche	
		glEnd();						// fin du cube
	glEndList();
}

/* Cre une Build List de 3 axes de longueur donne */
void BuildAxis(GLdouble length, GLuint genList)
{
	//GLuint list = glGenLists(1);
	length = length/2;
	glNewList(genList,GL_COMPILE);
		glBegin(GL_LINES);
			glColor3d(1.0,1.0,1.0);
			glVertex3f(-length,0.0f,0.0f); // dbut de x
			glVertex3f( length,0.0f,0.0f); // fin  de x
			glVertex3f(0.0f,-length,0.0f); // dbut de y
			glVertex3f(0.0f, length,0.0f); // fin de y
			glVertex3f(0.0f,0.0f,-length); // dbut de z
			glVertex3f(0.0f,0.0f, length); // fin de z
		glEnd();
	glEndList();
}

/* Affichage de la scne OpenGL */
void Draw()
{
	// Vide le buffer de couleur et le Z-buffer
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	glMatrixMode(GL_MODELVIEW) ;
	glLoadIdentity();

	// Dfinition du point de vue
	gluLookAt(
		2.0, 2.0,-5.0, 	// Vue lgrement sur le ct
		0.0, 0.0, 0.0, 	// On regarde le centre...
		0.0, 1.0, 0.0);	// ...verticalement

	// Axes
	glCallList(genList);
	
	// Sauvegarde de la matrice actuelle
	glPushMatrix();
	
	// Cube  l'origine, tourne sur lui-mme
	glRotated(.05*cpt,0.0,1.0,0.0);
	glCallList(genList+1);

	// On ressort la matrice de la pile, on re-sauve
	glPopMatrix();
	glPushMatrix();
	
	// Cube dcal sur x, tourne sur lui-mme
	glTranslated(2.0,0.0,0.0);
	glRotated(.04*cpt,0.0,1.0,0.0);
	glCallList(genList+1);

	// Encore une fois
	glPopMatrix();

	// Cube tournant autour de l'origine, tourne sur lui-mme
	glRotated(.03*cpt,-0.5,0.0,0.5);
	glTranslated(0.0,1.5,0.0);
	glRotated(.01*cpt,1.0,0.0,0.0);
	glRotated(.02*cpt,0.0,1.0,0.0);
	glRotated(.03*cpt,0.0,0.0,1.0);
	glCallList(genList+1);

	glutSwapBuffers(); // Intervertit les deux tampons

	glutPostRedisplay();	// Demande de redessiner la scene

	cpt++;
}

/* Redimensionnement */
void Reshape(int w, int h) 
{
	glMatrixMode(GL_MODELVIEW); 
	glLoadIdentity();
	glViewport(0,0,w,h);
	glClearDepth(1.0);
	glEnable(GL_DEPTH_TEST);
	//glDepthFunc(GL_LEQUAL);
	glMatrixMode(GL_PROJECTION); // On slectionne la matrice de 
								// projection
	glLoadIdentity();			// On initialise la matrice
	gluPerspective(45,(float) w/h,1.,500.);	// On rgle la perspective
}
